/* This file is part of the KDE libraries
    Copyright (C) 2009 Norbert Frese <nf2.email@gmail.com>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
 */

#ifndef GIONETWORKSTORAGE_H_
#define GIONETWORKSTORAGE_H_

#include <glib.h>
#include <gio/gio.h>

#include "kstorageiface.h"
#include "kstorage.h"
#include "giostorage.h"

class GioNetworkStorage : public GioStorage
{
    Q_OBJECT

public:

    GioNetworkStorage(GMount * gMount);

    ~GioNetworkStorage();

    /////

    bool isValid() const;

    QString id() const;

    QString displayName() const;

    QString icon() const;

    QStringList emblems() const;

    QUrl url() const;

    QString mountPointPath() const;

    bool isRemovable() const;

    bool isReleasable() const;

    bool isHotpluggable() const;

    bool isAccessible() const;

    KDiskFreeSpaceInfo freeSpace() const;

    ///// actions ////

    void tearDown(QObject * doneSignalTarget, const char * doneQSlot);

    //// members ////

    GMount * m_gMount;

};

#endif /* GioNetworkStorage_H_ */
